﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Phoenix;
using VRage.Game.Components;
using Sandbox.Definitions;
using VRageMath;
using VRage.ModAPI;
using VRage.ObjectBuilders;
using VRage;
using VRage.Game.Entity;
using Ingame = VRage.Game.ModAPI.Ingame;
using Sandbox.ModAPI.Interfaces;
using Sandbox.Common.ObjectBuilders;
using Sandbox.ModAPI;
using VRage.Game.ModAPI;
using SpaceEngineers.Game.ModAPI.Ingame;
using VRage.Game.ModAPI.Interfaces;
using Sandbox.Game;
using Sandbox.Game.Entities;
using VRage.Game;
using Sandbox.Common.ObjectBuilders.Definitions;
using VRage.Input;
using Sandbox.Game.EntityComponents;
using VRage.Utils;
using VRage.Game.Entity.UseObject;
using Sandbox.Game.Entities.Character.Components;
using VRageRender.Import;
using IMyControl = VRage.ModAPI.IMyControl;

namespace Phoenix.AutoOreCollect
{
#if false
    //[MyEntityComponentDescriptor(typeof(MyObjectBuilder_Drill))]
    public class CollectOreDrill : MyGameLogicComponent
    {
        private float m_radius;
        private bool m_enabled = true;

        public override MyObjectBuilder_EntityBase GetObjectBuilder(bool copy = false)
        {
            return Container.Entity.GetObjectBuilder(copy);
        }

        public override void Init(MyObjectBuilder_EntityBase objectBuilder)
        {
            //Container.Entity.NeedsUpdate |= MyEntityUpdateEnum.EACH_10TH_FRAME | MyEntityUpdateEnum.BEFORE_NEXT_FRAME;
            m_radius = CalculateRadius();
        }

        void CollectOreDrill_OnClosing(IMyEntity obj)
        {
            var block = (Container.Entity as IMyTerminalBlock);
            block.OnClosing -= CollectOreDrill_OnClosing;
            block.CustomNameChanged -= CollectOreDrill_CustomNameChanged;
        }

        void CollectOreDrill_CustomNameChanged(IMyTerminalBlock obj)
        {
            ParseNameArguments();
        }

        public void ParseNameArguments(string name = null)
        {
            if (name == null)
                name = (Container.Entity as IMyTerminalBlock).CustomName;

            if (string.IsNullOrWhiteSpace(name))
                return;

            int cmdStartIdx = name.IndexOf('[');
            int cmdEndIdx = name.LastIndexOf(']');

            // Set defaults
            m_enabled = AutoOreAdmin.Configuration.Enabled;

            try
            {
                // Check if we have custom commands in the name
                if (cmdStartIdx != -1 && cmdEndIdx != -1)
                {
                    string sCmd = name.Remove(cmdEndIdx).Remove(0, cmdStartIdx + 1);

                    // Split the commands for parsing
                    string[] cmds = sCmd.Split(new Char[] { ',', ';', '|' }, StringSplitOptions.RemoveEmptyEntries);

                    foreach (var cmd in cmds)
                    {
                        string tempCmd = cmd.Trim().ToUpperInvariant();

                        if (string.Compare(tempCmd, "NOCOLLECT", true) == 0)
                            m_enabled = false;
                        if (string.Compare(tempCmd, "COLLECT", true) == 0)
                            m_enabled = true;
                    }
                }
            }
            catch (Exception ex)
            {
            }
        }

        public override void UpdateOnceBeforeFrame()
        {
            if (!MyAPIGateway.Multiplayer.IsServer)
                return;

            var block = (Container.Entity as IMyTerminalBlock);

            if (block.BlockDefinition.SubtypeName.StartsWith("Large_SC_LaserDrill"))
            {
                m_enabled = false;
                return;
            }
            block.CustomNameChanged += CollectOreDrill_CustomNameChanged;
            block.OnClosing += CollectOreDrill_OnClosing;

            ParseNameArguments();
        }

        ulong m_counter = 0;
        public override void UpdateBeforeSimulation10()
        {
            if (m_enabled && MyAPIGateway.Multiplayer.IsServer)
            {
                if (m_counter++ % 2 != 0)
                    return;

                if (!(Container.Entity as IMyGunObject<Sandbox.Game.Weapons.MyToolBase>).IsShooting)
                    return;

                if (m_counter % 10 == 0)
                    ParseNameArguments();

                if (m_radius == default(float))
                    m_radius = CalculateRadius();

                Container.Entity.CollectOre(m_radius);
            }
        }

        float CalculateRadius()
        {
            float radius = default(float);
            try
            {
                var definitionId = new MyDefinitionId(typeof(MyObjectBuilder_Drill), (Container.Entity as IMyCubeBlock).BlockDefinition.SubtypeName);
                var definition = MyDefinitionManager.Static.GetDefinition(definitionId);
                radius = Math.Max((float)Container.Entity.WorldAABB.Extents.Max(),
                    (definition.GetObjectBuilder() as MyObjectBuilder_ShipDrillDefinition).SensorRadius);
            }
            catch
            {
                radius = (float)Container.Entity.WorldAABB.Extents.Max();
            }

            return radius;
        }
    }
#endif

    [MyEntityComponentDescriptor(typeof(MyObjectBuilder_HandDrill), false)]
    public class CollectOreHandDrill : MyGameLogicComponent
    {
        MyResourceSinkComponent m_sink = new MyResourceSinkComponent(1);

        public override MyObjectBuilder_EntityBase GetObjectBuilder(bool copy = false)
        {
            return Container.Entity.GetObjectBuilder(copy);
        }

        public override void Init(MyObjectBuilder_EntityBase objectBuilder)
        {
            NeedsUpdate |= MyEntityUpdateEnum.EACH_10TH_FRAME;

            if (MyAPIGateway.Session.LocalHumanPlayer != null)
                NeedsUpdate |= MyEntityUpdateEnum.EACH_FRAME;

            Container.Entity.OnClose += Entity_OnClose;
            //m_sink.Init(MyStringHash.GetOrCompute("Utility"), 0.0002f, GetPowerInput);
            //var charEnt = (Container.Entity as IMyGunBaseUser).Owner;
            //var charDistr = charEnt.Components.Get<MyResourceDistributorComponent>();
            //charDistr.AddSink(m_sink);
            NeedsUpdate |= MyEntityUpdateEnum.BEFORE_NEXT_FRAME;
        }

        private void Entity_OnClose(IMyEntity obj)
        {
            AutoOreAdmin.Instance.CollectionState = CollectionState.NoDrill;
            Container.Entity.OnClose -= Entity_OnClose;
        }

        private float GetPowerInput()
        {
            var player = MyAPIGateway.Players.GetPlayerControllingEntity((Container.Entity as IMyGunBaseUser).Owner);
            if ((Container.Entity as IMyHandheldGunObject<Sandbox.Game.Weapons.MyToolBase>).IsShooting &&
                (player != null && AutoOreAdmin.Configuration.IsEnabled(player.SteamUserId)))
                return 0.0002f;
            else
                return 0;
        }

        //public override void UpdateOnceBeforeFrame()
        //{
        //    MyAPIGateway.Utilities.ShowNotification("emissive", 5000);
        //    //Entity.SetEmissiveParts("Emissive", new Color(MyAPIGateway.Session.LocalHumanPlayer.Character.Render.ColorMaskHsv), 1.0f);
        //    //var drill = MyAPIGateway.Entities.GetEntity((b) => b is IMyShipDrill);
        //    //if (drill != null)
        //    //{
        //        //MyAPIGateway.Utilities.ShowNotification("Drill");
        //        //Entity.Name = "test";
        //        //MyAPIGateway.Entities.SetEntityName(Entity);
        //        //Sandbox.Game.MyVisualScriptLogicProvider.SetHighlight("test", color: Color.Green);
        //    //}

        //}
        public override void UpdateBeforeSimulation10()
        {
            try
            {
                if (MyAPIGateway.Session.Player != null)
                {
                    PlayerOptions player = new PlayerOptions();
                    AutoOreAdmin.Configuration?.PlayerData.Dictionary.TryGetValue(MyAPIGateway.Session.Player.SteamUserId, out player);

                    if (AutoOreAdmin.Configuration.Enabled && (player?.HandPickup ?? true))
                    {
                        if (!(Container.Entity as IMyHandheldGunObject<Sandbox.Game.Weapons.MyToolBase>).IsShooting)
                            AutoOreAdmin.Instance.CollectionState = CollectionState.Ready;
                        else
                            AutoOreAdmin.Instance.CollectionState = CollectionState.Collecting;
                    }
                    else
                    {
                        AutoOreAdmin.Instance.CollectionState = CollectionState.Off;
                    }
                }
            }
            catch(Exception ex)
            {
                Logger.Instance.LogException(ex);
            }

            // Collect floating ore
            if (MyAPIGateway.Session.Player != null)
            {
                if (!(Container.Entity as IMyHandheldGunObject<Sandbox.Game.Weapons.MyToolBase>).IsShooting)
                    return;

                Container.Entity.CollectOre((float)((Container.Entity as IMyGunBaseUser).Owner as IMyEntity).WorldVolume.Radius);
                m_sink.Update();
            }
        }

        public override void UpdateBeforeSimulation()
        {
            MyKeys key = MyKeys.T;
            IMyControl control;

            if ((control = MyAPIGateway.Input.GetControl(VRage.Input.MyKeys.T)) != null)
            {
                //if (control.GetControlName() != MyControlsSpace.CUBE_DEFAULT_MOUNTPOINT)
                //{
                //    key = MyKeys.R;

                //    if (MyAPIGateway.Input.GetControl(VRage.Input.MyKeys.R | MyKeys.Control) != null)
                //    {
                //        key = MyKeys.B;
                //    }
                //}
            }

            if (MyAPIGateway.Gui.GetCurrentScreen == MyTerminalPageEnum.None &&
                !MyAPIGateway.Gui.ChatEntryVisible &&
                MyAPIGateway.Input.IsNewKeyReleased(key) && MyAPIGateway.Input.IsAnyCtrlKeyPressed())
            {
                MessageUtils.SendMessageToServer(new MessagePlayerToggle() { });
            }

            //var gps = MyAPIGateway.Session.GPS.Create("foo", "bar", new Vector3D(0, 0, 0), true, Color.Red);
            //MyAPIGateway.Session.GPS.AddLocalGps(gps);
            //var sphere = new BoundingSphereD(MyAPIGateway.Session.Player.GetPosition(), 10);
            //var entities = MyAPIGateway.Entities.GetEntitiesInSphere(ref sphere);
            //var drill = entities.Where((e) => e is IMyShipDrill);
            //if ( drill.Count() > 0)
            //{
            //    var drl = drill.First();
            //    var comp = drl.Components.Get<MyUseObjectsComponentBase>();

            //    if( comp != null )
            //    {
            //        var objs = new List<IMyUseObject>();
            //        comp.GetInteractiveObjects<IMyUseObject>(objs);
            //        //MyAPIGateway.Utilities.ShowNotification("comp: " + objs.Count, 50);
            //        var detector = comp.RaycastDetectors(sphere.Center, drl.PositionComp.GetPosition());
            //        if( detector == "conveyor")
            //            MyAPIGateway.Utilities.ShowNotification("detector: " + detector, 50);
            //    }
            //    else
            //    {
            //        MyAPIGateway.Utilities.ShowNotification("comp null", 50);
            //    }
            //}
            //else
            //{
            //    MyAPIGateway.Utilities.ShowNotification("drill empty", 50);
            //}
            //Entity.Name = "test";
            //Sandbox.Game.MyVisualScriptLogicProvider.SetHighlight("test", color: Color.Green, playerId: MyAPIGateway.Session.Player.IdentityId);
        }
    }

    public static class DrillExtensionMethods
    {
        public static void CollectOre(this IMyEntity drill, float radius)
        {
            if (drill == null)
                return;

            // Collect floating ore
            var ores = new HashSet<IMyEntity>();
            var sphere = drill.WorldVolume;
            var drillEntity = drill as MyEntity;
            var invOwn = (drillEntity != null && drillEntity.HasInventory) ? drillEntity : null;
            try
            {
                if (invOwn == null)
                {
                    invOwn = (drill as IMyGunBaseUser).Owner;
                }
                sphere.Radius = radius * AutoOreAdmin.Configuration.RangeMultiplier;
                var player = MyAPIGateway.Players.GetPlayerControllingEntity(invOwn);

                if (invOwn != null)
                {
                    if (player != null && drill is IMyGunBaseUser && !AutoOreAdmin.Configuration.IsEnabled(player.SteamUserId))
                        return;

                    MyAPIGateway.Entities.GetEntities(ores, (x) => x is IMyFloatingObject && sphere.Contains(x.GetPosition()) != ContainmentType.Disjoint);
                    var oreList = new List<long>();
                    var deleteList = new List<long>();
                    foreach (var ore in ores)
                    {
                        if ((ore as MyFloatingObject).Item.Content.TypeId != typeof(MyObjectBuilder_Ore))
                            continue;

                        var collect = AutoOreAdmin.Configuration.Enabled ? OreCollectionMethod.Collect : OreCollectionMethod.NoCollect;

                        if (player != null)
                        {
                            var type = (ore as MyFloatingObject).Item.Content.SubtypeName;
                            collect = AutoOreAdmin.Configuration.GetCollectionMethod(player.SteamUserId, type.ToLowerInvariant());
                        }

                        if (collect == OreCollectionMethod.Collect)
                            oreList.Add(ore.EntityId);
                        //(invOwn.GetInventory(0) as MyInventory).AddEntity(ore);
                        //(invOwn.GetInventory(0) as MyInventory).TakeFloatingObject(ore as MyFloatingObject);
                        else if (collect == OreCollectionMethod.Destroy)
                            deleteList.Add(ore.EntityId);
                            //ore.Close();
                    }

                    if (oreList.Count > 0 || deleteList.Count > 0)
                        MessageUtils.SendMessageToServer(new MessageCollect()
                        {
                            InventoryOwner = invOwn.EntityId,
                            Entities = oreList.ToArray(),
                            EntitiesToDelete = deleteList.ToArray()
                        });
                }
            }
            catch(Exception ex)
            {
                Logger.Instance.LogException(ex);
            }
        }
    }
}
